package illustrers

// |@@| C

import (
	"context"
	"gardening/src/lib/kit"
	"gardening/src/lib/searcher"
	"gardening/src/mdl"
	"gardening/src/srv/stringers"
	"gitlab.com/ccyrillee/kitcla/goc"
)

type UserSearchIllustrer struct {
	Kit          *kit.Kit
	UserStringer *stringers.UserStringer
}

type UserSearchIllustrerMod struct {
	Ctx    context.Context
	Entity *mdl.User
	Value  *searcher.SearchValue
}

func (this *UserSearchIllustrer) Act(ctx context.Context, mod *UserSearchIllustrerMod) goc.HTML {
	return goc.H("div", goc.Attr{"class": "flex flex-row space-x-1"},
		this.text(ctx, mod),
		this.subText(ctx, mod),
	)
}
func (this *UserSearchIllustrer) text(ctx context.Context, mod *UserSearchIllustrerMod) goc.HTML {
	return this.Kit.Atoms.Cells.TextCell.TextCell(this.UserStringer.MustToString(mod.Entity))
}
func (this *UserSearchIllustrer) subText(ctx context.Context, mod *UserSearchIllustrerMod) goc.HTML {
	subText := "as User"
	if len(mod.Value.Scope) > 0 {
		subText += ", in "
	}
	for _, item := range mod.Value.Scope {
		subText += item.Text
	}
	return goc.H("div", goc.Attr{"class": "text-scale-7 italic"}, subText)
}
